var swf = null; // SET TO NULL UNTIL LOADED
var callbacks = new Array();

function registerAudioEvent(eventName, action) 
{
	callbacks[eventName] = action;
};

function playToggle() {
	swf.playToggle();
}
function playTrack() {
	swf.playTrack();
}
function pauseTrack() {
	swf.pauseTrack();
}
function stopTrack() {
	swf.stopTrack();
}
function getAudioState() {
	return swf.getPlayingState();
}
function loadTrack(newfile, as) 
{
	swf.loadFile(newfile, as);
}

function callback(name) {
	try {
		var o = callbacks[name];		
		if (typeof o === 'undefined')
			return;
		if (typeof(o) === "function")
		{
			o.call();
		} 

	} catch (e) {
		alert("exception: callback: " + e);
	}
}

// Functions invoked by Flash (Optional)
function onPlay() {
	callback('onPlay');
}

function onPause() {
	callback('onPause');
}

function onStop() {
	callback('onStop');
}

function onSongOver() {
	callback('onSongOver');
}
function onIOErro() {
	callback('onError');
}

function playNextTrack() {
	callback('playNextTrack');
}

function embedAudioPlayer() 
{
	var flashvars = {};
	var params = {};
	var attributes = {
		id : "audio",
		name : "audio"
	};

	swfobject.embedSWF("player.swf", "audio", "170", "80", "9", false,
			flashvars, params, attributes, function(e) 
			{
				swf = e.ref;
			});

}
