
var categoryType;// ["Setup", "Passwords","Information", "Logs"];
var tabView;
var tabs;
var layer0;
var initialTab = "";

// var Dom = YAHOO.util.Dom;
// var Event = YAHOO.util.Event;

var category = -1;	
function $(id) { return document.getElementById(id); }
var servlet = "/admin";
var info;	// initial tab info
var upgrading = false;


function expandCategoryTab(c)
{
	if (upgrading)
	{
		upgradingErr();
		return;
	}

	category = c;
	updateTabHTMLAjax();
}

var shown = false;
function upgradingErr()
{
	if (!shown)
	{
		shown = true;
		displayAlert("Upgrade in Progress", "SuperSync is upgrading... Try reloading in a few moments.");
	}
}

/**
 *	This function to show the error text message on ajax response
*/
function ajaxFailure( t ) 
{
	if (upgrading)
		upgradingErr();
	else
		displayAlert("Error", 'There was an error:' + t.statusText+".\n<BR> Try reloading page.");
}

/**
 *	Ajax call callback function
*/


if (typeof String.prototype.startsWith != 'function') {
  String.prototype.startsWith = function (str){
    return this.slice(0, str.length) == str;
  };
}




function updateTabHTML(t) 
{
	try {
		if (t.responseText.startsWith("path:"))
		{
			// alert(t.responseText);
			var path = t.responseText.slice(5, t.responseText.length);

			// alert(path);
			window.location.href = websiteUrl+path;

		}  else
		{
			var content = $(categoryType[category]+'_table');
			content.innerHTML = t.responseText;
			if (t.responseText.indexOf("LIVEREFRESH")>0)
				setTimeout(updateTabHTMLAjax, 2500);

			
		}
		
	}catch(e)
	{
		alert("catSuccess handler failed "+e);
	}
}

function ajaxPopulate(t) 
{
	try {
		var content = $('data');
		content.innerHTML = t.responseText;
	}catch(e)
	{
		alert("ajax "+ e);
	}
}



function updateTabHTMLAjax()
{
	// if (upgrading) { upgradingErr();return; }

	var categoryHandler = {
		success: updateTabHTML,
		failure: ajaxFailure
		};
	var u = servlet+"?tab="+categoryType[category]+"&ajax=1";	
	var call = YAHOO.util.Connect.asyncRequest('GET', u, categoryHandler);	
}


function ajax(args)
{
	var handler = {	success: ajaxPopulate, failure: ajaxFailure };
	call = YAHOO.util.Connect.asyncRequest('GET', servlet+"?"+args+"&ajax=1", handler);
}

var alertPanel;

function closeAlert()
{
	alertPanel.hide();
}

var countdownPanel;
var countdownValue = 60;
var countdownBody = '';

function countdown()
{
	if (countdownPanel)
	{
		if (--countdownValue<0)
		{
			countdownPanel.setBody("Update complete. Please click reload.");
		} else
		{
			countdownPanel.setBody(countdownBody+"\n"+countdownValue);
			setTimeout(countdown, 1000);
		}
	}
	
}

function countdownRestart()
{
	startCountdown('Please wait while SuperSync restarts.');
}


function startCountdown(msg)
{
	try  {
	countdownBody = msg;
	countdownPanel = new YAHOO.widget.SimpleDialog("countdownPanel", 
			{
				fixedcenter: false, 
				constraintoviewport: true, 
				underlay: "shadow", 
				close: false, 
				modal: true,
				width: '400px', 
				height: '150px', 
				visible: true, 
				draggable: false,
				zIndex:1500,
		 		buttons: [ 	]
				
			}
		);
		
		countdownValue = 60;
		countdownPanel.setHeader('Upgrade in progress');
		countdownPanel.setBody(countdownBody);
		countdownPanel.render(document.body);
		setTimeout(countdown, 1000);
		
		
	} catch(err)
	{
		showErr("countdownPanel error: "+err);
	}
}


function displayAlert(alertTitle, alertBody)
{
	try  {

		alertPanel = new YAHOO.widget.SimpleDialog("alertPanel", 
			{
				fixedcenter: false, 
				constraintoviewport: true, 
				underlay: "shadow", 
				close: true, 
				modal: true,
				width: '400px', 
				height: '150px', 
				visible: true, 
				draggable: false,
				zIndex:1500,
		 		buttons: [ 
		  			{ text:"OK",  handler:closeAlert, isDefault:true } 
		  		]
				
			}
		);
		
		alertPanel.setHeader(alertTitle);
		alertPanel.setBody(alertBody);
		alertPanel.render(document.body);
	} catch(err)
	{
		showErr("showAlert error: "+err);
	}
}

var yesNoPanel;

function hideYesNo()
{
	yesNoPanel.hide();
}

function askYesNo(alertTitle, alertBody, handleYes, handleNo)
{
	if (handleNo==null) 
		handleNo = hideYesNo;
	if (handleYes==null) 
		handleYes = hideYesNo;

	try  {

		yesNoPanel = new YAHOO.widget.SimpleDialog("alertPanel",
		{
		fixedcenter: false,
		constraintoviewport: true,
		underlay: "shadow",
		close: false,
		modal: true,
		width: '320px',
		height: '150px',
		visible: true,
		//text: '<img src="/images/questionmark.png" width="48" height="48">'+alertBody,	
		draggable: false,
		zIndex:1500,
 		buttons: [ 
 			{ text:"Yes", handler:handleYes },
  			{ text:"No",  handler:handleNo } // , isDefault:true 
  		]
	
		}
		); 
		
		var b2 = '<img src="/images/questionmark.png" width="48" height="48" style="vertical-align:text-top;float:left;  padding-right:5px;padding-top:0px;">'+alertBody;
		var table = '<table border="0"><tr><td><img src="/images/questionmark.png" width="48" height="48" style="vertical-align:text-top;float:left; padding:50px 50px; "></td><td><BR>'+alertBody+'</td></tr></table>';
		
		yesNoPanel.setBody(b2);
		yesNoPanel.setHeader(alertTitle);
		yesNoPanel.render(document.body);
		// alert(YAHOO.widget.SimpleDialog.ICON_HELP);
		
	} catch(err)
	{
		alert("showAlert error: "+err);
	}
}

function versionCheckHandler(t) 
{
	eval('vers='+t.responseText);
	displayAlert(vers.title, vers.body);
}

function checkVersion()
{
	if (upgrading) { upgradingErr();return; }

	var handler = {	success: versionCheckHandler, failure: ajaxFailure };
	call = YAHOO.util.Connect.asyncRequest('GET', servlet+"?cmd=version&ajax=1", handler);
}

function alertSuccess()
{
	// alert('success.');
}

function upgradingFailure()
{
	// alert('upgrading did not succeed');
}

function upgradingSuccess()
{
	startCountdown('Please wait while the SuperSync upgrade is installed.');
}



function doUpdate()
{
	try {
		hideYesNo();
		upgrading=true;
		var handler = {	success: upgradingSuccess, failure: upgradingFailure };
		call = YAHOO.util.Connect.asyncRequest('GET', servlet+"?cmd=application_update&ajax=1", handler);
	} catch(e)
	{
		alert(e);
	}
	
}

function doRestart()
{
	hideYesNo();	
	var handler = {	success: countdownRestart, failure: ajaxFailure };
	call = YAHOO.util.Connect.asyncRequest('GET', servlet+"?cmd=restart&ajax=1", handler);
}

function doRescan()
{
	hideYesNo();
	var handler = {	success: null, failure: ajaxFailure };
	call = YAHOO.util.Connect.asyncRequest('GET', servlet+"?cmd=rescan&ajax=1", handler);
}

function askUpdate()
{
	if (upgrading) { upgradingErr();return; }
	askYesNo("Do you want to upgrade?", "Upgrading will download the latest version from supersync.com.", doUpdate, null);
}

function askRestart()
{	
	askYesNo("Restart the SuperSync service?", "Click yes to restart this service. Please allow a minute for SuperSync services to return.", doRestart, null);
}

function startRescan()
{	
	if (upgrading) { upgradingErr();return; }
	askYesNo("Rescan your library?", "SuperSync will rescan your media, looking for tracks that have changed, or have been added or deleted. The rescan will be done in the background.", doRescan, null);
}


function createCategoryTab()
{

	try 
	{
		
 	tabView = new YAHOO.widget.TabView();
	for (x=0;x<categoryType.length;x++)
	{
		// create a simple tab with the content set to a div with id set to category
		// name, such as artist_table, search_table, etc.
		tabs[x] = new YAHOO.widget.Tab({label: categoryType[x],
		content: '<div id="'+categoryType[x]+'_table"></div>',
		active: x==category});
		tabView.addTab(tabs[x]);
	}

	// respond to tab events by changing the category to the new value.
	tabView.on('activeTabChange', function changeTab(ev) {	expandCategoryTab(tabView.get('activeIndex')); });
	tabView.appendTo('catDiv');
	}
	catch(e)
	{
		alert("createCategoryTab "+ e);
	}
	
}

function createLayer0()
{
	var def = {
		units: [{ position: 'center', resize: false, body: 'layer0Div', gutter: '8px' }]
	};

	layer0 = new YAHOO.widget.Layout(def);
	layer0.on('render', createCategoryTab);
	layer0.render();
}


function getURLParam(strParamName){
  var strReturn = "";
  var strHref = window.location.href;
  if ( strHref.indexOf("?") > -1 ){
	var strQueryString = strHref.substr(strHref.indexOf("?"));
	var aQueryString = strQueryString.split("&");
	for ( var iParam = 0; iParam < aQueryString.length; iParam++ ){
	  if (aQueryString[iParam].indexOf(strParamName.toLowerCase() + "=") > -1 ){
		var aParam = aQueryString[iParam].split("=");
		strReturn = aParam[1];
		break;
	  }
	}
  }
  return unescape(strReturn);
}


function tabSuccess(t) 
{
	try 
	{		
		eval('info='+t.responseText);		
		category = info.category;
		categoryType = info.tabs;
		tabs = new Array(categoryType.length);		
		createLayer0();
		
		expandCategoryTab(category);
	}catch(e)
	{
		alert("tabSuccess "+e);
	}
}

function initTabs()
{
	var handler = {	success: tabSuccess, failure: ajaxFailure };
	call = YAHOO.util.Connect.asyncRequest('GET', servlet+"?cmd=info&ajax=1&tab="+initialTab, handler);
}

function getInfo(what, id)
{
	var handler = {	success: tabSuccess, failure: ajaxFailure };
	call = YAHOO.util.Connect.asyncRequest('GET', servlet+"?cmd=info&ajax=1&what="+what+"&id="+id, handler);
}


function createLayout()
{
	initialTab = getURLParam("tab");
	initTabs();	
}


function doOnLoad()
{
	websiteUrl = "http://"+location.hostname+":"+location.port;	
}

/**
 *	This function is default load on window load.
*/
window.onload = doOnLoad;

YAHOO.util.Event.onDOMReady(createLayout);


