#!/bin/sh
#
# Shell script to run SuperSync start script

source /etc/profile
SS_LOG=/var/run/supersync.status
SS_PKGDEST=`pwd`
rm -f $SS_LOG

echo "start.sh : PKG DIR: $SS_PKGDEST" >> $SS_LOG

JAVA_EXEC=java
if [ -e "${JAVA_HOME}" ]
then
 JAVA_EXEC=${JAVA_HOME}/bin/java
fi
 
echo "JAVA_HOME: ${JAVA_HOME}" >> $SS_LOG
 
if [ -z "${SUPERSYNC_MAX_HEAP}" ]
then
 SUPERSYNC_MAX_HEAP=512M
fi
 
cd ${SS_PKGDEST}
 
echo -n "pwd :" >> $SS_LOG
pwd >> $SS_LOG
 
echo "Run supersync.jar" >> $SS_LOG
 
${JAVA_EXEC} -Xmx${SUPERSYNC_MAX_HEAP} -Dsun.jnu.encoding=UTF-8 -Dfile.encoding=UTF-8 -jar supersync.jar &
 
echo " java: error: $?" >> $SS_LOG
 
